* Program ...: Setcolor.PRG
* Author ....: Chuck Litzell
* Date ......: March 1, 1988
* Versions ..: dBASE III PLUS or Developer's Release.
* Notes .....: Sample program to demonstrate use of Attrib.BIN,
*              Go.BIN, Clickstr.BIN and Cchart.BIN.
*              Setcolor is an interactive program to set the normal
*              and enhanced colors in dBASE III PLUS. It uses
*              Attrib.BIN to find the current settings, then uses
*              Go.BIN to control selection of the new colors from a
*              color chart on the screen. Go.BIN is also used to
*              select from a "pop-up" exit menu. Clickstr is used to
*              display the prompts. If you don't want to use Clickstr
*              you could collapse the @...SAY and CALL Clickstr lines
*              into one and eliminate the CALL.
*
SET TALK OFF
SET STATUS OFF
SET PROCEDURE TO Colorutl
LOAD Go
LOAD Clickstr
binchart = FILE("Cchart.BIN")
IF binchart
   LOAD Cchart
ENDIF
* ---Find out current color settings.
original = ""
DO Getcolor WITH original
* ---Separate out foreground and background.
onorm = LEFT(original, AT(",", original) - 1)
oenha = STUFF(original, 1, AT(",", original), "")
* ---Draw background screen.
SET COLOR TO
CLEAR
@   3,  5 TO 17, 74 DOUBLE
@   2,  8 TO  4, 28 DOUBLE
@   3,  9 CLEAR TO  3, 27
@   2, 31 TO 19, 48 DOUBLE
@   3, 32 CLEAR TO 18, 47
@   3, 14 SAY "SET COLOR"
* ---Draw sample box for normal colors.
*
SET COLOR TO &onorm
@  6,  7 CLEAR TO 15, 29
@  6,  8 to 15, 28 DOUBLE
@ 10,  9 SAY "    N O R M A L    "
@ 11,  9 SAY "    C O L O R S    "
SET COLOR TO
@ 16,  7 CLEAR TO 16, 29
@ 16, (22 - LEN(onorm)) / 2 + 7 SAY onorm
* ---Draw sample box for enhanced colors.
SET COLOR TO &oenha
@  6, 50 CLEAR TO 15, 72
@  6, 51 TO 15, 71 DOUBLE
@ 10, 52 SAY "  E N H A N C E D  "
@ 11, 52 SAY "    C O L O R S    "
SET COLOR TO
@ 16, 51 CLEAR TO 16, 71
@ 16, (22 - LEN(oenha)) / 2 + 51 SAY oenha
IF binchart
   * ---Use the bin solution, if it's available.
   @ 3, 32 SAY ""
   CALL Cchart
ELSE
   * ---dBASE Code to draw color chart.
   * ---The outside DO WHILE loop controls the rows, and the
   * ---inside loop controls the columns. Background varies by
   * ---row and foreground varies by column.
   rowndx = 1
   temp = ""
   DO WHILE rowndx < 17
      colndx = 1
      @ rowndx + 2, 32 SAY SPACE(0)
      DO WHILE colndx < 17
         DO Decode WITH rowndx - 1, colndx - 1, temp
         SET COLOR TO &temp
         @ ROW(), COL() SAY CHR(4)
         colndx = colndx + 1
      ENDDO
      rowndx = rowndx + 1
   ENDDO
ENDIF
* ---Set up default colors.
ncolor = onorm
ecolor = oenha
* ---Initial cursor position.
lastr = 3
lastc = 33
* ---Main input loop.
DO WHILE .T.
   @ 14,  10 SAY ""
   CALL Clickstr WITH "SET NORMAL COLORS"
   * ---Confine cursor to region from 3, 32 TO 18, 47
   * ---Since we can't pass a CHR(0) to Go.BIN, the coordinates
   * ---are offset by 1.
   temp = CHR(3 + 1) + CHR(32 + 1) + CHR(18 + 1) + CHR(47 + 1)
   @ lastr, lastc SAY ""
   CALL Go WITH temp
   IF  ASC(SUBSTR(temp, 3)) = 13
      * ---If Return was pressed to exit, extract row and
      * ---column indices and adjust for color numbers.
      lastr = ASC(temp) - 1
      lastc = ASC(SUBSTR(temp, 2)) - 1
      DO Decode WITH lastc - 32, lastr - 3, ncolor
   ENDIF
   * ---Display new sample for normal colors.
   SET COLOR TO &ncolor
   @  6,  7 CLEAR TO 15, 29
   @  6,  8 TO 15, 28 DOUBLE
   @ 10,  9 SAY "    N O R M A L    "
   @ 11,  9 SAY "    C O L O R S    "
   SET COLOR TO
   @ 16,  7 CLEAR TO 16, 29
   @ 16, (22 - LEN(ncolor)) / 2 + 7 SAY ncolor
   *
   * ---Select enhanced colors in the same way.
   *
   @ 14, 52 SAY ""
   CALL Clickstr WITH "SET ENHANCED COLORS"
   temp = CHR(3 + 1) + CHR(32 + 1) + CHR(18 + 1) + CHR(47 + 1)
   @ lastr, lastc SAY ""
   CALL Go WITH temp
   IF ASC(SUBSTR(temp, 3)) = 13
      * ---If Return was pressed to exit, set up new
      * ---enhanced colors.
      lastr = ASC(temp) - 1
      lastc = ASC(SUBSTR(temp, 2)) - 1
      DO Decode WITH lastc - 32, lastr - 3, ecolor
   ENDIF
   * ---Display new sample for normal colors.
   SET COLOR TO &ecolor
   @  6, 50 CLEAR TO 15, 72
   @  6, 51 TO 15, 71 DOUBLE
   @ 10, 52 SAY "  E N H A N C E D  "
   @ 11, 52 SAY "    C O L O R S    "
   SET COLOR TO
   @ 16, 51 CLEAR TO 16, 71
   @ 16, (22 - LEN(ecolor)) / 2 + 51 SAY ecolor
   * ---Draw the "popup" menu.
   SET COLOR TO
   @ 17, 58 TO 21, 66 DOUBLE
   @ 18, 59 CLEAR TO 18, 65
   @ 18, 60 SAY "Set"
   @ 19, 60 SAY "Redo"
   @ 20, 60 SAY "Cancel"
   * ---Confine cursor to the three rows and the single column to
   * ---the left of the three menu selections.
   temp = CHR(18 + 1) + CHR(59 + 1) + CHR(20 + 1) + CHR(59 + 1)
   CALL Go WITH temp
   * ---Erase the popup menu.
   @ 17, 58 CLEAR TO 21, 69
   @ 17, 58 TO 17, 69 DOUBLE
   * ---Process the menu selection.
   DO CASE
   CASE ASC(temp) = 21 .OR. ASC(SUBSTR(temp, 3)) = 27
        * ---Return was pressed on Row 20, "Cancel",
        * ---or Escape was pressed.
        * ---Restore original colors and quit.
        SET COLOR TO &original
        EXIT
   CASE ASC(temp) = 19
        * ---Return was pressed on Row 18, "Set".
        * ---Set the new colors and quit.
        SET COLOR TO &ncolor, &ecolor
        EXIT
   CASE ASC(temp) = 20
        * ---Cursor was pressed on Row 19, "Redo".
        * ---Go back to top of loop.
        LOOP
   ENDCASE
ENDDO
CLEAR
RELEASE MODULE Go
RELEASE MODULE Clickstr
IF binchart
   RELEASE MODULE CChart
ENDIF
CLOSE PROCEDURE
RETURN
* EOP: Setcolor.PRG

